diff -Naur drupal-7.51/modules/simpletest/tests/form.test drupal-7.66/modules/simpletest/tests/form.test
--- drupal-7.51/modules/simpletest/tests/form.test	2016-10-05 20:45:42.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/form.test	2019-04-17 22:20:46.000000000 +0200
@@ -691,6 +691,14 @@
   }
 
   /**
+   * Tests that a form with a disabled CSRF token can be validated.
+   */
+  function testDisabledToken() {
+    $this->drupalPost('form-test/validate-no-token', array(), 'Save');
+    $this->assertText('The form_test_validate_no_token form has been submitted successfully.');
+  }
+
+  /**
    * Tests partial form validation through #limit_validation_errors.
    */
   function testValidateLimitErrors() {
@@ -1413,6 +1421,59 @@
 }
 
 /**
+ * Test cache_form.
+ */
+class FormsFormCacheTestCase extends DrupalWebTestCase {
+  public static function getInfo() {
+    return array(
+      'name' => 'Form caching',
+      'description' => 'Tests storage and retrieval of forms from cache.',
+      'group' => 'Form API',
+    );
+  }
+
+  function setUp() {
+    parent::setUp('form_test');
+  }
+
+  /**
+   * Tests storing and retrieving the form from cache.
+   */
+  function testCacheForm() {
+    $form = drupal_get_form('form_test_cache_form');
+    $form_state = array('foo' => 'bar', 'build_info' => array('baz'));
+    form_set_cache($form['#build_id'], $form, $form_state);
+
+    $cached_form_state = array();
+    $cached_form = form_get_cache($form['#build_id'], $cached_form_state);
+
+    $this->assertEqual($cached_form['#build_id'], $form['#build_id'], 'Form retrieved from cache_form successfully.');
+    $this->assertEqual($cached_form_state['foo'], 'bar', 'Data retrieved from cache_form successfully.');
+  }
+
+  /**
+   * Tests changing form_cache_expiration.
+   */
+  function testCacheFormCustomExpiration() {
+    variable_set('form_cache_expiration', -1 * (24 * 60 * 60));
+
+    $form = drupal_get_form('form_test_cache_form');
+    $form_state = array('foo' => 'bar', 'build_info' => array('baz'));
+    form_set_cache($form['#build_id'], $form, $form_state);
+
+    // Clear expired entries from cache_form, which should include the entry we
+    // just stored. Without this, the form will still be retrieved from cache.
+    cache_clear_all(NULL, 'cache_form');
+
+    $cached_form_state = array();
+    $cached_form = form_get_cache($form['#build_id'], $cached_form_state);
+
+    $this->assertNull($cached_form, 'Expired form was not returned from cache.');
+    $this->assertTrue(empty($cached_form_state), 'No data retrieved from cache for expired form.');
+  }
+}
+
+/**
  * Test wrapper form callbacks.
  */
 class FormsFormWrapperTestCase extends DrupalWebTestCase {
diff -Naur drupal-7.51/modules/simpletest/tests/form_test.info drupal-7.66/modules/simpletest/tests/form_test.info
--- drupal-7.51/modules/simpletest/tests/form_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/form_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/form_test.module drupal-7.66/modules/simpletest/tests/form_test.module
--- drupal-7.51/modules/simpletest/tests/form_test.module	2016-10-05 20:45:42.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/form_test.module	2019-04-17 22:20:46.000000000 +0200
@@ -37,6 +37,13 @@
     'access callback' => TRUE,
     'type' => MENU_CALLBACK,
   );
+  $items['form-test/validate-no-token'] = array(
+    'title' => 'Form validation without a CSRF token',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('form_test_validate_no_token'),
+    'access callback' => TRUE,
+    'type' => MENU_CALLBACK,
+  );
   $items['form-test/limit-validation-errors'] = array(
     'title' => 'Form validation with some error suppression',
     'page callback' => 'drupal_get_form',
@@ -455,6 +462,27 @@
 }
 
 /**
+ * Form builder for testing submission of a form without a CSRF token.
+ */
+function form_test_validate_no_token($form, &$form_state) {
+  $form['submit'] = array(
+    '#type' => 'submit',
+    '#value' => 'Save',
+  );
+
+  $form['#token'] = FALSE;
+
+  return $form;
+}
+
+/**
+ * Form submission handler for form_test_validate_no_token().
+ */
+function form_test_validate_no_token_submit($form, &$form_state) {
+  drupal_set_message('The form_test_validate_no_token form has been submitted successfully.');
+}
+
+/**
  * Builds a simple form with a button triggering partial validation.
  */
 function form_test_limit_validation_errors_form($form, &$form_state) {
@@ -891,6 +919,24 @@
 }
 
 /**
+ * A simple form for testing form caching.
+ */
+function form_test_cache_form($form, &$form_state) {
+  $form['title'] = array(
+    '#type' => 'textfield',
+    '#title' => 'Title',
+    '#required' => TRUE,
+  );
+
+  $form['submit'] = array(
+    '#type' => 'submit',
+    '#value' => 'Save',
+  );
+
+  return $form;
+}
+
+/**
  * A form for testing form labels and required marks.
  */
 function form_label_test_form() {
diff -Naur drupal-7.51/modules/simpletest/tests/image.test drupal-7.66/modules/simpletest/tests/image.test
--- drupal-7.51/modules/simpletest/tests/image.test	2016-10-05 20:45:42.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/image.test	2019-04-17 22:20:46.000000000 +0200
@@ -335,7 +335,9 @@
     );
 
     // Systems using non-bundled GD2 don't have imagerotate. Test if available.
-    if (function_exists('imagerotate')) {
+    // @todo Remove the version check once https://www.drupal.org/node/2918570
+    //   is resolved.
+    if (function_exists('imagerotate') && (version_compare(PHP_VERSION, '7.0.26', '<') || (version_compare(PHP_VERSION, '7.1', '>=') && version_compare(PHP_VERSION, '7.1.12', '<')))) {
       $operations += array(
         'rotate_90' => array(
           'function' => 'rotate',
@@ -357,8 +359,8 @@
       // See https://bugs.php.net/bug.php?id=65148.
       // For the 40x20 test images, the dimensions resulting from rotation will
       // be 1 pixel smaller in both width and height in PHP 5.5 and above.
-      // @todo: If and when the PHP bug gets solved, add an upper limit
-      //   version check.
+      // @todo: The PHP bug was fixed in PHP 7.0.26 and 7.1.12. Change the code
+      //   below to reflect that in https://www.drupal.org/node/2918570.
       if (version_compare(PHP_VERSION, '5.5', '>=')) {
         $operations += array(
           'rotate_5' => array(
diff -Naur drupal-7.51/modules/simpletest/tests/image_test.info drupal-7.66/modules/simpletest/tests/image_test.info
--- drupal-7.51/modules/simpletest/tests/image_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/image_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/menu_test.info drupal-7.66/modules/simpletest/tests/menu_test.info
--- drupal-7.51/modules/simpletest/tests/menu_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/menu_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/module_test.info drupal-7.66/modules/simpletest/tests/module_test.info
--- drupal-7.51/modules/simpletest/tests/module_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/module_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/path_test.info drupal-7.66/modules/simpletest/tests/path_test.info
--- drupal-7.51/modules/simpletest/tests/path_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/path_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/psr_0_test/psr_0_test.info drupal-7.66/modules/simpletest/tests/psr_0_test/psr_0_test.info
--- drupal-7.51/modules/simpletest/tests/psr_0_test/psr_0_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/psr_0_test/psr_0_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 hidden = TRUE
 package = Testing
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/psr_4_test/psr_4_test.info drupal-7.66/modules/simpletest/tests/psr_4_test/psr_4_test.info
--- drupal-7.51/modules/simpletest/tests/psr_4_test/psr_4_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/psr_4_test/psr_4_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 hidden = TRUE
 package = Testing
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/requirements1_test.info drupal-7.66/modules/simpletest/tests/requirements1_test.info
--- drupal-7.51/modules/simpletest/tests/requirements1_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/requirements1_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/requirements2_test.info drupal-7.66/modules/simpletest/tests/requirements2_test.info
--- drupal-7.51/modules/simpletest/tests/requirements2_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/requirements2_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -7,8 +7,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/session_test.info drupal-7.66/modules/simpletest/tests/session_test.info
--- drupal-7.51/modules/simpletest/tests/session_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/session_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/system_dependencies_test.info drupal-7.66/modules/simpletest/tests/system_dependencies_test.info
--- drupal-7.51/modules/simpletest/tests/system_dependencies_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/system_dependencies_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 hidden = TRUE
 dependencies[] = _missing_dependency
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/system_incompatible_core_version_dependencies_test.info drupal-7.66/modules/simpletest/tests/system_incompatible_core_version_dependencies_test.info
--- drupal-7.51/modules/simpletest/tests/system_incompatible_core_version_dependencies_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/system_incompatible_core_version_dependencies_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 hidden = TRUE
 dependencies[] = system_incompatible_core_version_test
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/system_incompatible_core_version_test.info drupal-7.66/modules/simpletest/tests/system_incompatible_core_version_test.info
--- drupal-7.51/modules/simpletest/tests/system_incompatible_core_version_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/system_incompatible_core_version_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 5.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/system_incompatible_module_version_dependencies_test.info drupal-7.66/modules/simpletest/tests/system_incompatible_module_version_dependencies_test.info
--- drupal-7.51/modules/simpletest/tests/system_incompatible_module_version_dependencies_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/system_incompatible_module_version_dependencies_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -7,8 +7,7 @@
 ; system_incompatible_module_version_test declares version 1.0
 dependencies[] = system_incompatible_module_version_test (>2.0)
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/system_incompatible_module_version_test.info drupal-7.66/modules/simpletest/tests/system_incompatible_module_version_test.info
--- drupal-7.51/modules/simpletest/tests/system_incompatible_module_version_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/system_incompatible_module_version_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/system_project_namespace_test.info drupal-7.66/modules/simpletest/tests/system_project_namespace_test.info
--- drupal-7.51/modules/simpletest/tests/system_project_namespace_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/system_project_namespace_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 hidden = TRUE
 dependencies[] = drupal:filter
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/system_test.info drupal-7.66/modules/simpletest/tests/system_test.info
--- drupal-7.51/modules/simpletest/tests/system_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/system_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 files[] = system_test.module
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/taxonomy_test.info drupal-7.66/modules/simpletest/tests/taxonomy_test.info
--- drupal-7.51/modules/simpletest/tests/taxonomy_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/taxonomy_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 hidden = TRUE
 dependencies[] = taxonomy
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/taxonomy_test.module drupal-7.66/modules/simpletest/tests/taxonomy_test.module
--- drupal-7.51/modules/simpletest/tests/taxonomy_test.module	2016-10-05 20:45:42.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/taxonomy_test.module	2019-04-17 22:20:46.000000000 +0200
@@ -109,3 +109,33 @@
     ->execute()
     ->fetchField();
 }
+
+/**
+ * Implements hook_query_alter().
+ */
+function taxonomy_test_query_alter(QueryAlterableInterface $query) {
+  $value = variable_get(__FUNCTION__);
+  if (isset($value)) {
+    variable_set(__FUNCTION__, ++$value);
+  }
+}
+
+/**
+ * Implements hook_query_TAG_alter().
+ */
+function taxonomy_test_query_term_access_alter(QueryAlterableInterface $query) {
+  $value = variable_get(__FUNCTION__);
+  if (isset($value)) {
+    variable_set(__FUNCTION__, ++$value);
+  }
+}
+
+/**
+ * Implements hook_query_TAG_alter().
+ */
+function taxonomy_test_query_taxonomy_term_access_alter(QueryAlterableInterface $query) {
+  $value = variable_get(__FUNCTION__);
+  if (isset($value)) {
+    variable_set(__FUNCTION__, ++$value);
+  }
+}
diff -Naur drupal-7.51/modules/simpletest/tests/theme.test drupal-7.66/modules/simpletest/tests/theme.test
--- drupal-7.51/modules/simpletest/tests/theme.test	2016-10-05 20:45:42.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/theme.test	2019-04-17 22:20:46.000000000 +0200
@@ -646,3 +646,34 @@
   }
 
 }
+
+/**
+ * Tests module-provided theme engines.
+ */
+class ModuleProvidedThemeEngineTestCase extends DrupalWebTestCase {
+
+  public static function getInfo() {
+    return array(
+      'name' => 'Theme engine test',
+      'description' => 'Tests module-provided theme engines.',
+      'group' => 'Theme',
+    );
+  }
+
+  function setUp() {
+    parent::setUp('theme_test');
+    theme_enable(array('test_theme', 'test_theme_nyan_cat'));
+  }
+
+  /**
+   * Ensures that the module provided theme engine is found and used by core.
+   */
+  function testEngineIsFoundAndWorking() {
+    variable_set('theme_default', 'test_theme_nyan_cat');
+    variable_set('admin_theme', 'test_theme_nyan_cat');
+
+    $this->drupalGet('theme-test/engine-info-test');
+    $this->assertText('Miaou');
+  }
+
+}
diff -Naur drupal-7.51/modules/simpletest/tests/theme_test.info drupal-7.66/modules/simpletest/tests/theme_test.info
--- drupal-7.51/modules/simpletest/tests/theme_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/theme_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/theme_test.module drupal-7.66/modules/simpletest/tests/theme_test.module
--- drupal-7.51/modules/simpletest/tests/theme_test.module	2016-10-05 20:45:42.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/theme_test.module	2019-04-17 22:20:46.000000000 +0200
@@ -27,10 +27,19 @@
   $themes['test_theme'] = drupal_get_path('module', 'theme_test') . '/themes/test_theme/test_theme.info';
   $themes['test_basetheme'] = drupal_get_path('module', 'theme_test') . '/themes/test_basetheme/test_basetheme.info';
   $themes['test_subtheme'] = drupal_get_path('module', 'theme_test') . '/themes/test_subtheme/test_subtheme.info';
+  $themes['test_theme_nyan_cat'] = drupal_get_path('module', 'theme_test') . '/themes/test_theme_nyan_cat/test_theme_nyan_cat.info';
   return $themes;
 }
 
 /**
+ * Implements hook_system_theme_engine_info().
+ */
+function theme_test_system_theme_engine_info() {
+  $theme_engines['nyan_cat'] = drupal_get_path('module', 'theme_test') . '/themes/engines/nyan_cat/nyan_cat.engine';
+  return $theme_engines;
+}
+
+/**
  * Implements hook_menu().
  */
 function theme_test_menu() {
@@ -58,6 +67,12 @@
     'access callback' => TRUE,
     'type' => MENU_CALLBACK,
   );
+  $items['theme-test/engine-info-test'] = array(
+    'description' => "Serves a simple page rendered using a Nyan Cat theme engine template.",
+    'page callback' => '_theme_test_engine_info_test',
+    'access callback' => TRUE,
+    'type' => MENU_CALLBACK,
+  );
   return $items;
 }
 
@@ -140,6 +155,15 @@
 }
 
 /**
+ * Serves a simple page renderered using a Nyan Cat theme engine template.
+ */
+function _theme_test_engine_info_test() {
+  return array(
+    '#markup' => theme('theme_test_template_test'),
+  );
+}
+
+/**
  * Theme function for testing theme('theme_test_foo').
  */
 function theme_theme_test_foo($variables) {
diff -Naur drupal-7.51/modules/simpletest/tests/themes/test_basetheme/test_basetheme.info drupal-7.66/modules/simpletest/tests/themes/test_basetheme/test_basetheme.info
--- drupal-7.51/modules/simpletest/tests/themes/test_basetheme/test_basetheme.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/themes/test_basetheme/test_basetheme.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 settings[basetheme_only] = base theme value
 settings[subtheme_override] = base theme value
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/themes/test_subtheme/test_subtheme.info drupal-7.66/modules/simpletest/tests/themes/test_subtheme/test_subtheme.info
--- drupal-7.51/modules/simpletest/tests/themes/test_subtheme/test_subtheme.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/themes/test_subtheme/test_subtheme.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 
 settings[subtheme_override] = subtheme value
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/themes/test_theme/test_theme.info drupal-7.66/modules/simpletest/tests/themes/test_theme/test_theme.info
--- drupal-7.51/modules/simpletest/tests/themes/test_theme/test_theme.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/themes/test_theme/test_theme.info	2019-04-17 22:39:36.000000000 +0200
@@ -17,8 +17,7 @@
 
 settings[theme_test_setting] = default value
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/themes/test_theme/theme-settings.php drupal-7.66/modules/simpletest/tests/themes/test_theme/theme-settings.php
--- drupal-7.51/modules/simpletest/tests/themes/test_theme/theme-settings.php	1970-01-01 01:00:00.000000000 +0100
+++ drupal-7.66/modules/simpletest/tests/themes/test_theme/theme-settings.php	2019-04-17 22:20:46.000000000 +0200
@@ -0,0 +1,32 @@
+<?php
+
+/**
+ * @file
+ * Theme setting callbacks for the test_theme theme.
+ */
+
+/**
+ * Implements hook_form_FORM_ID_alter().
+ */
+function test_theme_form_system_theme_settings_alter(&$form, &$form_state) {
+  $form['test_theme_checkbox'] = array(
+    '#type' => 'checkbox',
+    '#title' => 'Test theme checkbox',
+    '#default_value' => theme_get_setting('test_theme_checkbox'),
+  );
+
+  // Force the form to be cached so we can test that this file is properly
+  // loaded and the custom submit handler is properly called even on a cached
+  // form build.
+  $form_state['cache'] = TRUE;
+  $form['#submit'][] = 'test_theme_form_system_theme_settings_submit';
+}
+
+/**
+ * Form submission handler for the test theme settings form.
+ *
+ * @see test_theme_form_system_theme_settings_alter()
+ */
+function test_theme_form_system_theme_settings_submit($form, &$form_state) {
+  drupal_set_message('The test theme setting was saved.');
+}
diff -Naur drupal-7.51/modules/simpletest/tests/themes/test_theme_nyan_cat/test_theme_nyan_cat.info drupal-7.66/modules/simpletest/tests/themes/test_theme_nyan_cat/test_theme_nyan_cat.info
--- drupal-7.51/modules/simpletest/tests/themes/test_theme_nyan_cat/test_theme_nyan_cat.info	1970-01-01 01:00:00.000000000 +0100
+++ drupal-7.66/modules/simpletest/tests/themes/test_theme_nyan_cat/test_theme_nyan_cat.info	2019-04-17 22:39:36.000000000 +0200
@@ -0,0 +1,10 @@
+name = Nyan cat engine based test theme
+description = Theme for testing the module-provided theme engines.
+core = 7.x
+hidden = TRUE
+engine = nyan_cat
+
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
+project = "drupal"
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/update_script_test.info drupal-7.66/modules/simpletest/tests/update_script_test.info
--- drupal-7.51/modules/simpletest/tests/update_script_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/update_script_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/update_test_1.info drupal-7.66/modules/simpletest/tests/update_test_1.info
--- drupal-7.51/modules/simpletest/tests/update_test_1.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/update_test_1.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/update_test_2.info drupal-7.66/modules/simpletest/tests/update_test_2.info
--- drupal-7.51/modules/simpletest/tests/update_test_2.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/update_test_2.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/update_test_3.info drupal-7.66/modules/simpletest/tests/update_test_3.info
--- drupal-7.51/modules/simpletest/tests/update_test_3.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/update_test_3.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/url_alter_test.info drupal-7.66/modules/simpletest/tests/url_alter_test.info
--- drupal-7.51/modules/simpletest/tests/url_alter_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/url_alter_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 version = VERSION
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/simpletest/tests/xmlrpc_test.info drupal-7.66/modules/simpletest/tests/xmlrpc_test.info
--- drupal-7.51/modules/simpletest/tests/xmlrpc_test.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/simpletest/tests/xmlrpc_test.info	2019-04-17 22:39:36.000000000 +0200
@@ -5,8 +5,7 @@
 core = 7.x
 hidden = TRUE
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/statistics/statistics.info drupal-7.66/modules/statistics/statistics.info
--- drupal-7.51/modules/statistics/statistics.info	2016-10-05 21:02:54.000000000 +0200
+++ drupal-7.66/modules/statistics/statistics.info	2019-04-17 22:39:36.000000000 +0200
@@ -6,8 +6,7 @@
 files[] = statistics.test
 configure = admin/config/system/statistics
 
-; Information added by Drupal.org packaging script on 2016-10-05
-version = "7.51"
+; Information added by Drupal.org packaging script on 2019-04-17
+version = "7.66"
 project = "drupal"
-datestamp = "1475694174"
-
+datestamp = "1555533576"
diff -Naur drupal-7.51/modules/statistics/statistics.module drupal-7.66/modules/statistics/statistics.module
--- drupal-7.51/modules/statistics/statistics.module	2016-10-05 20:45:42.000000000 +0200
+++ drupal-7.66/modules/statistics/statistics.module	2019-04-17 22:20:46.000000000 +0200
@@ -245,7 +245,7 @@
  * Implements hook_cron().
  */
 function statistics_cron() {
-  $statistics_timestamp = variable_get('statistics_day_timestamp', '');
+  $statistics_timestamp = variable_get('statistics_day_timestamp', 0);
 
   if ((REQUEST_TIME - $statistics_timestamp) >= 86400) {
     // Reset day counts.
